#import "SSMenu.h"
#import "AppDelegate.h"

#define USE_JERRYS_WORKAROUND 1

@implementation SSMenu

- (id)initWithTitle:(NSString*)title {
	self = [super initWithTitle:title];
	if (self != nil) {
		// Debug/Logging Stuff
		NSLog(@"Initlizing menu %x %@ at level %i", self, [self title], [self level]) ;		
		[[[NSApp delegate] menus] addObject:[NSValue valueWithPointer:self]] ;
	}
	return self;
}

- (int)level {
	int level = 0 ;
	NSMenu* curMenu = self ;
	while((curMenu = [curMenu supermenu])) {
		level++ ;
	}
	
	return level ;
}

- (void)removeSubmenusFromAllItems {
    int lastIndex = [[self itemArray] count] - 1 ;
    int i ;
    for (i=lastIndex; i>=0; i--) {
        NSMenuItem* item = [self itemAtIndex:i] ;
        [item setSubmenu:nil] ;
    }
}

- (void) dealloc {
	// Debug/Logging Stuff
	NSMutableArray* menus = [[NSApp delegate] menus] ;
	[menus removeObject:[NSValue valueWithPointer:self]] ;
	NSLog(@"Dealoccing menu %x %@ at level %i", self, [self title], [self level]) ;

#ifdef USE_JERRYS_WORKAROUND
    [self removeSubmenusFromAllItems] ;
#endif
	
    [super dealloc] ;
}

- (id)retain {
    return [super retain] ;
}

- (void)release {
    [super release] ;
}

@end
